diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
index 49e438226..8bd03d6df 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weathers.java
@@ -2,15 +2,49 @@ package net.minecraft.core.world.weather;
 
 public abstract class Weathers {
     public static final Weather[] WEATHERS = new Weather[16];
-    public static final Weather OVERWORLD_CLEAR = new WeatherClear(0).setLanguageKey("overworld.clear");
-    public static final Weather OVERWORLD_RAIN = new WeatherRain(1).setLanguageKey("overworld.rain").setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0).setSubtractLightLevel(3).setSpawnRainParticles(true).setFogDistance(0.5f);
-    public static final Weather OVERWORLD_SNOW = new WeatherSnow(2).setLanguageKey("overworld.snow").setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1).setSubtractLightLevel(1).setFogDistance(0.5f);
-    public static final Weather OVERWORLD_STORM = new WeatherStorm(3).setLanguageKey("overworld.storm").setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0).setSubtractLightLevel(5).setSpawnRainParticles(true).setMobsSpawnInDaylight().setFogDistance(0.4f);
-    public static final Weather OVERWORLD_FOG = new WeatherClear(4).setLanguageKey("overworld.fog").setFogDistance(0.125f);
-    public static final Weather OVERWORLD_CLEAR_HELL = new WeatherClear(5).setLanguageKey("overworld.clear.hell").setSubtractLightLevel(7);
-    public static final Weather OVERWORLD_CLEAR_WOODS = new WeatherClear(6).setLanguageKey("overworld.clear.woods").setSubtractLightLevel(2);
-    public static final Weather OVERWORLD_WINTER_SNOW = new WeatherSnow(7).setLanguageKey("overworld.winter.snow").setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1);
-    public static final Weather OVERWORLD_RAIN_BLOOD = new WeatherStorm(8).setLanguageKey("overworld.rain.blood").setPrecipitation("/assets/minecraft/textures/environment/rain_blood.png", 2).setSubtractLightLevel(5).setMobsSpawnInDaylight().setFogDistance(0.4f);
+    public static final Weather OVERWORLD_CLEAR = new WeatherClear(0)
+        .setLanguageKey("overworld.clear");
+    public static final Weather OVERWORLD_RAIN = new WeatherRain(1)
+        .setLanguageKey("overworld.rain")
+        .setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0)
+        .setSubtractLightLevel(3)
+        .setSpawnRainParticles(true)
+        .setFogDistance(0.5f)
+        .setDamp();
+    public static final Weather OVERWORLD_SNOW = new WeatherSnow(2)
+        .setLanguageKey("overworld.snow")
+        .setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1)
+        .setSubtractLightLevel(1)
+        .setFogDistance(0.5f)
+        .setDamp();
+    public static final Weather OVERWORLD_STORM = new WeatherStorm(3)
+        .setLanguageKey("overworld.storm")
+        .setPrecipitation("/assets/minecraft/textures/environment/rain.png", 0)
+        .setSubtractLightLevel(5)
+        .setSpawnRainParticles(true)
+        .setMobsSpawnInDaylight()
+        .setFogDistance(0.4f)
+        .setDamp();
+    public static final Weather OVERWORLD_FOG = new WeatherClear(4)
+        .setLanguageKey("overworld.fog")
+        .setFogDistance(0.125f);
+    public static final Weather OVERWORLD_CLEAR_HELL = new WeatherClear(5)
+        .setLanguageKey("overworld.clear.hell")
+        .setSubtractLightLevel(7);
+    public static final Weather OVERWORLD_CLEAR_WOODS = new WeatherClear(6)
+        .setLanguageKey("overworld.clear.woods")
+        .setSubtractLightLevel(2);
+    public static final Weather OVERWORLD_WINTER_SNOW = new WeatherSnow(7)
+        .setLanguageKey("overworld.winter.snow")
+        .setPrecipitation("/assets/minecraft/textures/environment/snow.png", 1)
+        .setDamp();
+    public static final Weather OVERWORLD_RAIN_BLOOD = new WeatherStorm(8)
+        .setLanguageKey("overworld.rain.blood")
+        .setPrecipitation("/assets/minecraft/textures/environment/rain_blood.png", 2)
+        .setSubtractLightLevel(5)
+        .setMobsSpawnInDaylight()
+        .setFogDistance(0.4f)
+        .setDamp();
 
     public static Weather getWeatherByLanguageKey(String string) {
         for(Weather weather : WEATHERS) {
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 057e7aae6..1676e3720 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -172,7 +172,8 @@ public class PacketHandlerServer extends PacketHandler
             playerEntity.xd = xd;
             playerEntity.zd = zd;
             // TODO: Is this needing? It does allow for fast-tick exploits.
-            //worldserver.func_12017_b((Entity) playerEntity.vehicle, true);
+            // Update: Removing it breaks boats, so keep it for now
+            worldserver.updateEntityWithOptionalForce(((Entity) playerEntity.vehicle), false);
             playerEntity.vehicle.positionRider();
             return;
         }
@@ -538,6 +539,9 @@ public class PacketHandlerServer extends PacketHandler
         if (updatePlayerStatePacket.state == PacketUpdatePlayerState.STATE_SNEAK)
         {
             playerEntity.setSneaking(true);
+            if (playerEntity.vehicle != null) {
+                playerEntity.vehicle.ejectRider();
+            }
         }
         else if (updatePlayerStatePacket.state == PacketUpdatePlayerState.STATE_UN_SNEAK)
         {
@@ -552,8 +556,8 @@ public class PacketHandlerServer extends PacketHandler
     @Override
     public void handleBoatControl(PacketBoatControl boatControlPacket)
     {
-        if (!canInteract()) return;
-        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof EntityBoat && !Double.isNaN(boatControlPacket.targetXD) && !Double.isNaN(boatControlPacket.targetZD)) {
+        if (!canInteract() || Double.isNaN(boatControlPacket.targetXD) || Double.isNaN(boatControlPacket.targetZD)) return;
+        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof EntityBoat) {
             EntityBoat boat = (EntityBoat) playerEntity.vehicle;
             boat.handleControlDirect(boatControlPacket.targetXD, boatControlPacket.targetZD, boatControlPacket.targetYRot);
             boatControlPacket.entityId = boat.id;
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 719c013b0..b1f1b84ca 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -29,15 +29,6 @@ public class WorldServer extends World
         mcServer = minecraftserver;
     }
 
-    @Override
-    public void updateEntityWithOptionalForce(Entity entity, boolean flag)
-    {
-        if(!(entity.passenger instanceof Player))
-        {
-            super.updateEntityWithOptionalForce(entity, flag);
-        }
-    }
-
     @Override
     protected IChunkProvider createChunkProvider()
     {
